<template>
  <li :class="getStyleClass" @click="onFocusTask">
    <PAvatar
      :label="assignee.slice(0, 1)"
      class="Task__AssignedTo p-mr-2"
      :class="{ 'Task__AssignedTo--none': !props.task.assignedTo }"
      shape="circle"
      :title="props.task.assignedTo ? assignee : t('resource.task.notAssigned')"
    />
    <span class="Task__Title">
      <router-link
        :to="{ name: ROUTES.TASK.name, params: { uuid: props.task.id } }"
        class="Task__TitleLink"
      >
        {{ props.task.title }}
      </router-link>
    </span>
    <span
      v-if="props.task.durationMin || props.task.durationMax"
      class="Task__Duration"
      :title="t('resource.task.duration')"
    >
      <i class="mdi mdi-clock-fast"></i>
      {{ displayDuration(props.task) }}
    </span>

    <span
      v-if="props.task.endDate"
      class="mdi mdi-check-circle-outline Task__Closed"
      :title="t('resource.task.closed')"
    ></span>

    <span
      v-if="props.task.startDate && !props.task.endDate"
      class="Task__StartDate"
      :title="t('resource.task.startDate')"
    >
      {{ moment(task.startDate).format('DD/MM LT') }}
    </span>
  </li>
</template>
<script lang="ts" setup>
import { Task } from '@/api'
import { ROUTES } from '@/plugins'
import moment from 'moment-timezone'
import { useI18n } from 'vue-i18n'
import { computed, ref, watchEffect } from 'vue'
import { injectStrict } from '@/injectStrict'
import { ProvidedResources, ResourcesKey } from '@/provided'

const Resources = injectStrict<ProvidedResources>(ResourcesKey)
const { t } = useI18n()
const assignee = ref<string>('')

const props = defineProps<{
  task: Task
  focusedTask?: Task['id']
}>()

const emits = defineEmits<{
  /**
   * Fires when the task item is clicked
   */
  (e: 'update:task-focus', value: Task['id']): void
}>()

watchEffect(async () => {
  if (props.task.assignedTo) {
    assignee.value = await Resources.getWorkforceName(props.task.assignedTo)
  } else {
    assignee.value = ''
  }
})

/**
 * Display estimated duration of a task like:
 *  - 1h to 2h, if durations are different
 *  - 1h, if durations are equals
 */
const displayDuration = (task: Task): string => {
  const minDuration = moment.duration(task.durationMin, 'minutes').humanize()
  const maxDuration = moment.duration(task.durationMax, 'minutes').humanize()
  let duration = minDuration

  if (minDuration !== maxDuration) {
    duration = t('resource.task.estimatedDuration', {
      min: minDuration,
      max: maxDuration,
    })
  }

  return duration
}

/**
 * Returns css class to be applied for each task, to highlight the focused one
 */
const getStyleClass = computed(() => ({
  Task: true,
  'Task--focused': props.focusedTask === props.task['id'],
  'Task--closed': props.task.endDate,
}))

/**
 * Fires event if the task is focused
 * Prevents the event to be triggered as side effect
 * when deleting the task
 */
function onFocusTask() {
  emits('update:task-focus', props.task.id)
}
</script>
<style lang="scss" scoped>
@use 'src/style/variables' as v;
@use 'src/style/mixins' as m;

.Task {
  $root: &;

  display: grid;
  grid-template-areas:
    'left top right'
    'left bottom startDate';
  grid-template-rows: repeat(2, minmax(min-content, auto));
  grid-template-columns: 2rem 1fr minmax(min-content, auto);
  gap: v.$spacing-2;
  margin-bottom: 5px;
  padding: v.$spacing-2;
  border: solid 1px var(--surface-d);
  border-radius: v.$borderRadius;
  background-color: var(--surface-0);
  font-size: 0.9rem;
  cursor: pointer;

  &--focused {
    @extend .Task;

    @include m.mobile {
      border: inherit;
    }

    border: solid 1px #8f8f8f;
  }

  &:last-child {
    margin-bottom: 0;
  }

  &__Title {
    grid-area: top;

    &Link {
      color: var(--text-color);
      font-weight: 500;
      text-decoration: none;

      &:hover {
        text-decoration: underline;
      }
    }
  }

  &__Duration,
  &__CreatedAt {
    grid-area: bottom;
    color: var(--text-color-secondary);
  }

  &__AssignedTo {
    grid-area: left;
    align-self: center;
    text-transform: uppercase;

    &--none.p-avatar {
      border: solid 1px var(--surface-border);
      background: transparent;
    }
  }

  &__StartDate {
    grid-area: startDate;
    justify-self: right;
    color: var(--text-color-secondary);
    font-size: 0.9rem;
  }

  &__Closed {
    color: var(--success-color);
  }

  &--closed {
    border-left: 5px solid var(--success-color);
  }
}
</style>
